% Matlab Script File zum Ueben einfacher Befehle
%
% loesen von linearen Gleichungssystemen
%
% Applikationssoftware und Programmierung
% TU Graz SS 2001
% Winfried Kernbichler
%
% input   : Eingabe
% disp    : Dient zur Anzeige
% pause   : Stoppt Ausfuehrung und wartet auf Tastendruck
% ;       : Resultat wird nicht angezeigt
% ' '     : Kennzeichnet Zeichenketten (Strings)
% num2str : Umwandlung von Zahlen in Zeichenkketten
% plot    : Einfache graphische Darstellung
% clc     : Loescht den Ausgabebildschirm
%
% Viel Erfolg, viel Spass! 
% 
% Student(in): 
% Datum:


% ****************** Beispiel 1 ********************
clc   % loescht den Ausgabebildschirm
disp('Beispiel 1');
disp(' ');

% Koeffizientenmatrix
K = [1, -1, 1 ; 0, 10, 25 ; 20, 10, 0]

% Erster Inhomogenenvektor
b1 = [0; 90; 80]

% loesen der ersten Gleichung
X1 = K\b1;

% Ausgabe der Loesung
disp(['Die Stroeme fuer den 1. Fall sind: i1=',num2str(X1(1),3),', i2=', ...
        num2str(X1(2),3),', i3=',num2str(X1(3),3),', ']);


% Zweiter Inhomogenenvektor
b2 = [0; 125; 90]

% loesen der zweiten Gleichung
X2 = K\b2;

% Ausgabe der Loesung
disp(['Die Stroeme fuer den 2. Fall sind: i1=',num2str(X2(1),3),', i2=', ...
        num2str(X2(2),3),', i3=',num2str(X2(3),3),', ']);
disp(' ');

disp('Pause - Bitte Taste druecken!'); pause


% ****************** Beispiel 2 ********************
clc  % loescht den Ausgabebildschirm
disp('Beispiel 2');
disp(' ');

% Matrix A
A = [1, 2, -1 ; 3, 4, 0 ; -2, 3, 1]

% Vektor b
b = [3; 15; 11]

% Loesen von A x = b
x1 = A\b;

% Ausgabe der Loesung
disp('Die Loesung von A*x1=b ist:')
x1
disp(' ');

%Loesen von x A = b^T
x2 = b.'/A;

% Ausgabe der Loesung
disp('Die Loesung von x2*A=b ist:')
x2
disp(' ');

disp('Pause - Bitte Taste druecken!'); pause


% ****************** Beispiel 3 ********************
clc  % loescht den Ausgabebildschirm
disp('Beispiel 3');
disp(' ');

n = 5;
% Matrix M
M = eye(2*n) + 0.5*diag(ones(2*n-1,1),1) + 0.5*diag(ones(2*n-1,1),-1)
disp('Pause - Bitte Taste druecken!'); pause
disp(' ');

% Vektor v
v = zeros(2*n,1);
% v( logical(repmat((0:1)',n,1))) = 1:n
v(2:2:2*n)=1:n

% Loesung des Problems
disp('Loesung der Gleichung M*y = v:');
y = M\v
disp('Pause - Bitte Taste druecken!'); pause
disp(' ');

% naive Probe:
disp('Naive Probe M*y-v:')
M*y - v
disp('Pause - Bitte Taste druecken!'); pause
disp(' ');

% bessere Probe
disp('Bessere Probe: all( abs(M*y - v)<error_limit )')
disp(' ');
error_limit = 1.0e-8;
if all( abs(M*y - v)<error_limit )
    disp('Probe erfolgreich durchgefuehrt!')
else
    disp('Fehler bei der Probe aufgetaucht!')
end
