% This is just a test for arrays, cells and structures

echo on
% Create three 1000*1000 arrays with random numbers
xr1 = rand(1000);
xr2 = rand(1000);
xr3 = rand(1000);

% Record the speed of some calculations
tic;
test1s = sum(sum( xr1.*xr2 - xr3 ));
toc

% Put the same data into cells
ce{1} = xr1; ce{2} = xr2; ce{3} = xr3;
ce

% Test the speed again
tic;
test2s = sum(sum( ce{1}.*ce{2} - ce{3} ));
toc

% One can convert the cells to multidimensional arrays.
% Here it is assumed that all parts of the cell have the same dimension.
vec = [length(ce)  size(ce{1})];
arr = zeros(vec);
for ic=1:3,arr(ic,:) = ce{ic}(:);end

% Test the speed again
tic;
test3s = sum(sum( arr(1,:).*arr(2,:) - arr(3,:) ));
toc

% Here is a structure
dstruct = dir('*.m')

% One can convert structures to cells
dcell   = struct2cell(dstruct);

% Example for addressing data in cells and structures
dstruct(4).name
dcell{1,4}
