function [x,y,z] = func2d3(xi,yi,a,b,c,d,e,f)
% Die Funktion func2d3 berechnet 
% z(x,y) = a*x^2 + b*x*y + c*y^2 + d*x + e*y + f 
% Inputparameter werden berprft.
%
% Input:  Vektoren xi und yi
%         Skalare Konstanten a, b, c, d, e, f
% Output: x, y, Funktion z(x,y)
%         Fehlervariable ERR - global

% Autor:  Winfried Kernbichler
% Datum:  5.11.1999

global ERR
% berprfung der Anzahl der Inputparameter
% Die Variable nargin gibt die Anzahl der Inputparameter an.
if (nargin <= 1), x = -1:0.1:1; else x = xi; end
if (nargin <= 2), y = -1:0.1:1; else y = yi; end

% Defaultwerte fr die Konstanten a, b, c, d, e
if (nargin <= 2), a = 1; end
if (nargin <= 3), b = 1; end
if (nargin <= 4), c = 1; end
if (nargin <= 5), d = 0; end
if (nargin <= 6), e = 0; end
if (nargin <= 7), f = 0; end

% berprfung der Konstanten mit Hilfe einer Subfunction
err = 0;
if ( ~isscalar(a) | ~isscalar(b) | ~isscalar(c) | ...
      ~isscalar(d) | ~isscalar(e) ...
      )
   err = 1;
end
ERR = err;

if ( ~err),
	[xx,yy] = meshgrid(x,y); % Netzgitter in Form zweier Matrizen
   z = a.*xx.^2 + b.*xx.*yy + c.*yy.^2 + d.*xx + e.*yy + f; % FunKtion
else
   z = [];
end

% Subfunction isscalar
function [res] = isscalar(x)
% berprft ob die Variable x
% eine Zahl, und
% reell, und
% ein Skalar ist.
res = isnumeric(x) & isreal(x) & length(x)==1; 
% Beachte, die Verkettung mit dem logischen Operator & ('und')

% Die Subfunktionen ist nur hier aufrufbar. 
% Auerhalb der Routine func2d3 ist sie nicht bekannt, da kein 
% File isscalar.m besteht.
