% Script fr Funktionsdarstellung und Zeitmessung.
% Diskussion des Unterschieds zwischen Array-Arithmetik und Schleifen
%
% Bentigt die Funktionen func2d1, func2d1a und myplot1
%
% Autor: Winfried Kernbichler, 7.11.1999

echo off;
clc; % Lscht bestehende Anzeige im Commandwindow

% Schreiben einer berschrift
fprintf(1,'\tScript fr Funktionsdarstellung und Zeitmessung. \n')
fprintf(1,'\tDiskussion des Unterschieds zwischen Array-Arithmetik und Schleifen \n\n')
fprintf(1,'\t\tAutor: Winfried Kernbichler, 7.11.1999 \n\n')
% Hier ist der File Identifier FID=1 : Ausgabe am Schirm

% Definition der Inputvektoren
x = -1:0.1:1;
y = -2:0.1:2;
fprintf(1,'Die Lnge der Inputvektoren x und y ist: \n')
fprintf(1,'  x: %2.0f  y: %2.0f \n\n',length(x),length(y));
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Aufruf der Funktion
fprintf(1,'Aufruf der Funktion und graphische Darstellung. \n')
z = func2d1(x,y); 
fprintf(1,'Die Dimension der Matrix z ist: \n')
fprintf(1,'  z: %2.0f  %2.0f \n\n',size(z));
% ffnen eines Fensters fr die graphische Darstellung
fig1=figure(1);
p1 = myplot1(x,y,z);
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Was macht der Befehl meshgrid
fprintf(1,'Graphische Erluterung des Befehls meshgrid. \n\n')
[xx,yy] = meshgrid(x,y);
% ffnen einer Graphischen Darstellung
fig1; clf;
% Sie soll in 4 Teile (2 mal 2) aufgeteilt werden.
% Wie bei Matrizen (2 Zeilen, 2 Spalten)
subplot(2,2,1);
mesh(x,y,xx);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Die restlichen drei Plots funktionieren gleich.
subplot(2,2,2); mesh(x,y,yy);
xlabel('x'); ylabel('y'); zlabel('yy'); title('YY-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,2,3); mesh(x,y,xx+yy);
xlabel('x'); ylabel('y'); zlabel('xx+yy'); title('Summe');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,2,4); mesh(x,y,xx.*yy);
xlabel('x'); ylabel('y'); zlabel('xx.*yy'); title('Produkt');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

clf; % Clears Figure

fprintf(1,'Diskussion der Zeitmessung. \n\n');
% Genauere Auflsung (kleinere Schrittweiten)
% Unterschied zwischen Matrizenarithmetik und Schleifen
fprintf(1,'Verwendung lngerer Vektoren: \n')
x1 = -1:0.01:1; y1 = -2:0.02:2;
% Die Befehle tic und toc ermglichen Zeitmessung fr dazwischen
% liegende Befehle
% tic: Anfangsmarke
% toc: Zeit von Anfangsmarke aus gemessen.
tic; z1 = func2d1(x1,y1); t1=toc;
fprintf(1,'Die Dimension der Matrix z1 ist nun: \n')
fprintf(1,'  z1: %2.0f  %2.0f \n\n',size(z1));

% Darstellung in einer neuen Graphik
fig1; clf;
p1 = myplot1(x1,y1,z1); drawnow;
fprintf(1,'Zur Entfernung der Linien eine Taste drcken. \n\n');pause

% Entfernen der Linien aus der Zeichnung
% Beim Zeichnen wurde vorher ein Handle definiert, mit dessen Hilfe man nun
% den Plot ndern kann.
set(p1,'EdgeColor','none'); drawnow;

fprintf(1,'Zur Berechnung des Zeitverlusts mit for Schleifen eine Taste drcken. \n\n');pause
% Aufruf der Funktion mit Schleifen
fprintf(1,'Aufruf der Funktion mit Schleifen und Zeitmessung. \n\n');
fprintf(1,'Bitte warten. \n\n');
tic;z2 = func2d1a(x1,y1);t2=toc;
fprintf(1,'Zeit: \tArray \tLoop\n');
fprintf(1,'\t%12.8e  \t%12.8e \n',t1,t2);
if (t1 ~= 0) % Durchfhrung nur wenn t1 nicht 0 ist (Division!)
   fprintf(1,'Zeitverlustfaktor durch Schleifen: \n');
   fprintf(1,'\t%7.4f \n\n',t2/t1);
end
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
close(fig1);
fprintf(1,'Erluterung relationaler Operatoren \n');
fprintf(1,'und ihre Verwendung bei Arrays \n\n');
x = -1:0.1:1; y = -1:0.1:1; [xx,yy] = meshgrid(x,y);
fig1; clf;
% Sie soll in 4 Teile (2 mal 2) aufgeteilt werden.
% Wie bei Matrizen (2 Zeilen, 2 Spalten)
subplot(2,2,1);
mesh(x,y,xx);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Zur Erinnerung, wie die YY-Werte ausgesehen haben
mesh(x,y,yy);
xlabel('x'); ylabel('y'); zlabel('yy');
title('YY-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% und zurck zu den XX-Werten.
mesh(x,y,xx);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');

% Ausschneiden eines Streifens in x-Richtung.
fprintf(1,'Ausschneiden eines Streifens in x-Richtung. \n\n');
rad = 0.5;
xxs = xx; xxs( (yy > -rad) & (yy < rad) ) = NaN; 
subplot(2,2,2);
mesh(x,y,xxs);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Ausschneiden eines Streifens in y-Richtung.
fprintf(1,'Ausschneiden eines Streifens in y-Richtung. \n\n');
rad = 0.5;
xxs1 = xx; xxs1( (abs(xx) < rad) ) = NaN; 
subplot(2,2,3);
mesh(x,y,xxs1);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Ausschneiden eines Kreises.
fprintf(1,'Ausschneiden eines Kreises. \n\n');
rad = 0.5;
xxs2 = xx; xxs2( (xx.^2 + yy.^2) < rad.^2 ) = NaN; 
subplot(2,2,4);
mesh(x,y,xxs2);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Das Ganze mit besserer Auflsung.
x = -1:0.02:1; y = -1:0.02:1; [xx,yy] = meshgrid(x,y);
xxs2 = xx; xxs2( (xx.^2 + yy.^2) < rad.^2 ) = NaN; 
mesh(x,y,xxs2);
xlabel('x'); ylabel('y'); zlabel('xx');
title('XX-Werte');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Man kann auch etwas zu einem Plot hinzufgen.
hold on; % Lt die Zeichnung auch bei einem neuen Zusatz stehen.
% Fgt einen Kreis mit anderer Richtung ein.
yys2 = yy; yys2( (xx.^2 + yy.^2) >= rad.^2 ) = NaN;
mesh(x,y,yys2);
hold off; % Schaltet den Modus hinzufgen wieder aus
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

fprintf(1,'Erluterung logischer Operatoren \n');
fprintf(1,'und ihre Verwendung bei Arrays \n\n');

a = [ones(9,3),zeros(9,3),ones(9,3)];
b = [zeros(3,9);ones(3,9);zeros(3,9)];     
fig1; clf;
% Sie soll in 4 Teile (2 mal 2) aufgeteilt werden.
% Wie bei Matrizen (2 Zeilen, 2 Spalten).
p1 = subplot(2,3,1);
imagesc(a);
set(gca,'XTick',[],'YTick',[])
axis square;
title('a');
colormap([1 1 1;0 0 0]);

subplot(2,3,2);
imagesc(b);
set(gca,'XTick',[],'YTick',[])
title('b');
axis square;
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,3,3);
imagesc(~b);
set(gca,'XTick',[],'YTick',[])
title('not(b)    ~b');
axis square;
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,3,4);
imagesc(a&b);
set(gca,'XTick',[],'YTick',[])
title('and(a,b)    a&b');
axis square;
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,3,5);
imagesc(a|b);
set(gca,'XTick',[],'YTick',[])
title('or(a,b)     a|b');
axis square;
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,3,6);
imagesc(xor(a,b));
set(gca,'XTick',[],'YTick',[])
title('xor(a,b)');
axis square;

fprintf(1,'Zur Beendung des Scripts eine Taste drcken. \n\n');pause
% Schlieen der Figuren
colormap('default')
close(fig1);
% Lschen der Variablen
clear x y z xx yy x1 y1 z1 z2
clear t1 t2
clear fig1 p1
clear a rad xxs1 yys2      
clear b xxs xxs2      

fprintf(1,'Danke. \n\n');pause

