function handlesub(action,par1,par2)
% Handles all the callback for routione handletest

% Make global settings
global m n x legpol legpola

fig1    = findobj('Tag','figure1');
lh1     = findobj('Tag','line1');
lh1t    = findobj('Tag','line1t');
ax1     = findobj('Tag','ax1');
lh2     = findobj('Tag','line2');
lh2t    = findobj('Tag','line2t');
ax2     = findobj('Tag','ax2');
sl1     = findobj('Tag','slider1');
sl2     = findobj('Tag','slider2');
menu11  = findobj('Tag','menu11');
menu12  = findobj('Tag','menu12');
edit1 = findobj('Tag','edit1');
edit2 = findobj('Tag','edit2');

switch action
   
% Define callback action of slider 1
case 'slider1'
   
   n = floor(get(sl1,'Value'));
   set(sl1,'Value',n)
   
   legpol = legval(n,x);
   set(lh1,'XData',x,'YData',legpol')
   axes(ax1)
   title(strcat('Legendre Polynomial of Order n=',int2str(n)))
   
   m = min(n,m);
   if n==0
      set(sl2,'Enable','off')
      set(edit2,'Enable','off')
      set(edit2,'String','0')
   else
      set(sl2,'Enable','on')
      set(sl2,'Max',n)
      set(sl2,'Value',m)
      set(edit2,'String',num2str(m))
      set(edit2,'Enable','on')
      
      maxval = get(sl2,'Max');
      minval = get(sl2,'Min');
      step = 1 / (maxval-minval);
      set(sl2,'SliderStep',[step-eps min(1,2*step)])
  
   end
   
   legpola = legzval(n,x);
   set(lh2,'XData',x,'YData',legpola(m+1,:)')
   axes(ax2)
   title(strcat('Ass. Legendre Functions with m=',int2str(m)))
   
   text2max = findobj('Tag','text2max');
   set(text2max,'String',int2str(n))
   
   set(lh1t,'XData',[],'YData',[])
   set(lh2t,'XData',[],'YData',[])
   set(ax1,'YLimMode','auto')
   set(ax2,'YLimMode','auto')
   
   set(edit1,'String',num2str(n))
   
   maxval = get(sl1,'Max');
   minval = get(sl1,'Min');
   step = 1 / (maxval-minval);
   %set(sl1,'SliderStep',[step-eps min(1,2*step)])
  	%get(sl1,'SliderStep')
   
% Define callback action of slider 2 
case 'slider2'
   
   m = round(get(sl2,'Value'));
   set(gcbo,'Value',m)
   
   legpola = legzval(n,x);
   set(lh2,'XData',x,'YData',legpola(m+1,:)')
   axes(ax2)
   title(strcat('Ass. Legendre Functions with m=',int2str(m)))
   
   set(lh1t,'XData',[],'YData',[])
   set(lh2t,'XData',[],'YData',[])
   set(ax1,'YLimMode','auto')
   set(ax2,'YLimMode','auto')
   
   set(edit2,'String',num2str(m))
   
   maxval = get(sl2,'Max');
   minval = get(sl2,'Min');
   step = 1 / (maxval-minval);
   set(sl2,'SliderStep',[step-eps min(1,2*step)])
   
% Define callback action for edit1  
case 'edit1'
   
   val = round(str2num(get(gcbo,'String')));
   maxval = get(sl1,'Max');
   minval = get(sl1,'Min');
   val = min(val,maxval);
   val = max(val,minval);
   set(edit1,'String',num2str(val));
   set(sl1,'Value',val);
   handlesub('slider1');
      
% D2fine callback action for edit2   
case 'edit2'
   
   val = round(str2num(get(gcbo,'String')));
   maxval = get(sl2,'Max');
   minval = get(sl2,'Min');
   val = min(val,maxval);
   val = max(val,minval);
   set(edit2,'String',num2str(val));
   set(sl2,'Value',val);
   handlesub('slider2');
   
% Define callback action of menue11
case 'menu11'
   
   label = get(gcbo,'Label');
   if strcmp(label,'Grid off')
      axes(ax1)
      grid off
      axes(ax2)
      grid off
      set(gcbo,'Label','Grid on')
   elseif strcmp(label,'Grid on')
      axes(ax1)
      grid on
      axes(ax2)
      grid on
      set(gcbo,'Label','Grid off')
   end
   
case 'menu12'
   % Define callback action of menue12
   label = get(gcbo,'Label');
   if strcmp(label,'Axis off')
      axes(ax1)
      axis off
      axes(ax2)
      axis off
      set(gcbo,'Label','Axis on')
   elseif strcmp(label,'Axis on')
      axes(ax1)
      axis on
      axes(ax2)
      axis on
      set(gcbo,'Label','Axis off')
   end
   
case 'zoom'
   % Define callback action of zoom
   axes(ax1);
   sel_type = get(fig1,'SelectionType');
   cpoint = get(ax1,'CurrentPoint');
   x1 = cpoint(1,1); y1 = cpoint(1,2);
   if ~strcmp(sel_type,'normal')
      set(ax1,'XLimMode','auto')
      set(ax2,'XLimMode','auto')
   else
      fin_rec = rbbox;
      cpoint = get(ax1,'CurrentPoint');
      x2 = cpoint(1,1); y2 = cpoint(1,2);
      xlimold = get(ax1,'XLim');
      if abs(x1-x2)<eps
         xlim = [x1 x2];
         xlim=xlim + (xlimold-xlim)/2.;
      elseif x1<x2
         xlim=[x1 x2];
      else
         xlim=[x2 x1];
      end
      if xlim(1)<xlimold(1),xlim(1)=xlimold(1);end
      if xlim(2)>xlimold(2),xlim(2)=xlimold(2);end
         
      set(ax1,'XLim',xlim)
      set(ax2,'XLim',xlim)
   end
   set(ax1,'YLimMode','auto')
   set(ax2,'YLimMode','auto')
   
case 'tang'
   % Define callback action of tang
   axes(ax2)
   sel_type = get(fig1,'SelectionType');
   cpoint = get(ax2,'CurrentPoint');
   x1 = cpoint(1,1); y1 = cpoint(1,2);
   if ~strcmp(sel_type,'normal')
      set(lh1t,'XData',[],'YData',[])
      set(lh2t,'XData',[],'YData',[])
   else
      ind = max(find(x<=x1));
      xt = x(ind);
      yt = legpol(ind);
      kt = (legpol(ind+1)-legpol(ind))/(x(ind+1)-x(ind));
      yta = legpola(m+1,ind);
      kta = (legpola(m+1,ind+1)-legpola(m+1,ind))/(x(ind+1)-x(ind));
      xf=[xt-2 xt xt+2];
      yf=[yt-2*kt,yt,yt+2*kt];
      yfa=[yta-2*kta,yta,yta+2*kta];
      set(ax1,'XLimMode','manual')
      set(ax1,'YLimMode','manual')
      set(lh1t,'XData',xf,'YData',yf,'Color','green')
      set(ax2,'XLimMode','manual')
      set(ax2,'YLimMode','manual')
      set(lh2t,'XData',xf,'YData',yfa,'Color','green')
   end
         
end
