% Script fr Achsenpositionierung
%
% Winfried Kernbichler     28.11.1999

echo off; clc

fig1 = figure(1);
% Achsenmittelpunkt
xmid = 0.5; ymid = 0.5;
% Achsenausdehnung
xext = 0.4; yext = 0.4;
% Daraus linke untere Ecke
xll = xmid - xext/2;
yll = ymid - yext/2;
% Erstes Achsensystem
ax(1) = axes('Position',[xll,yll,xext,yext], ...
   'XTickLabel',[], 'YTickLabel',[], 'Box','on' );

% Zweites Achsensystem ber ganze Figur (unsichtbar)
axu = axes('Position',[0 0 1 1], ...
   'Visible','off', ...
   'Xlim',[0 1],'YLim',[0 1] ...
   );

% Linien fr Koordinaten
lh(1) = line([0,xll],[yll,yll]);
lh(2) = line([xll,xll],[0,yll]);
lh(3) = line([xll,xll+xext],[yll,yll]);
lh(4) = line([xll,xll],[yll,yll+yext]);
lh(5) = line([0,xmid],[ymid,ymid]);
lh(6) = line([xmid,xmid],[0,ymid]);

set(lh,'LineWidth',2,'Color','red'); % Alle Lines
set(lh(3:4),'Color','blue');
set(lh(5:6),'Color','green');


disp('PAUSE MODE');pause

% Linien unsichbarmachen
set(lh,'Visible','off');

% Verschieben von Achsen
shift = [0.1 -0.1 0 0];
set(ax(1),'Position',get(ax(1),'Position')+shift);

disp('PAUSE MODE');pause
% Und zurck
set(ax(1),'Position',get(ax(1),'Position')-shift);

disp('PAUSE MODE');pause
% Kopieren der Achse
ax(2) = copyobj(ax(1),fig1);
ax(3) = copyobj(ax(1),fig1);
ax(4) = copyobj(ax(1),fig1);

% Verteilen der Achsen
newp = [0.05 0.05 xext yext];
set(ax(1),'Position',newp); % Anwendung auf ax(1)
newp = [0.55 0.05 xext yext];
set(ax(2),'Position',newp);
newp = [0.05 0.55 xext yext];
set(ax(3),'Position',newp);
newp = [0.55 0.55 xext yext];
set(ax(4),'Position',newp);

% Alle Achsen gleiche Hintergrundfarbe
set(ax,'Color',[1 1 0.5]); % Anwendung auf ax

disp('PAUSE MODE');pause

% Lschen von Teilen
delete(ax(2:3)); % Lscht Handles (nicht nur unsichtbar)

disp('PAUSE MODE');pause
close(fig1);