% Interpolation und Extrapolation
%
% Autor Winfried Kernbichler 12.12.1999
echo off; clc;

% Originaldaten
xs = 0.0; xe = 2*pi; xn = 10;
x = linspace(xs,xe,xn);
y = sin(x);

% x-Werte mit grerem Bereich und mehr Punkten
xextra = pi/2; % Fr Extrapolation
xis = -xextra; xie = 2*pi + xextra; xin = 500;
xi = linspace(xis,xie,xin);

% Interpolationsmethoden
method = 'nearest';
yi1 = interp1(x,y,xi,method);
method = 'linear';
yi2 = interp1(x,y,xi,method);
method = 'cubic';
yi3 = interp1(x,y,xi,method);
method = 'spline';
yi4 = interp1(x,y,xi,method);

% Darstellung
fig1 = figure(1);clf;
ax(1)=subplot(2,2,1); plot(x,y,'ro',xi,yi1,'b'); title('Method: nearest');
ax(2)=subplot(2,2,2); plot(x,y,'ro',xi,yi2,'b'); title('Method:  linear');
ax(3)=subplot(2,2,3); plot(x,y,'ro',xi,yi3,'b'); title('Method:   cubic');
ax(4)=subplot(2,2,4); plot(x,y,'ro',xi,yi4,'b'); title('Method:  spline');
set(ax,'Xlim',[xis,xie]);

disp('PAUSE MODE'); pause;

% Ableitungen
dx = diff(xi); xid = xi(1:end-1);
dyi1 = diff(yi1) ./ dx;
dyi2 = diff(yi2) ./ dx;
dyi3 = diff(yi3) ./ dx;
dyi4 = diff(yi4) ./ dx;

% Darstellung der Ableitungen
fig2 = figure(2);clf;
aax(1)=subplot(2,2,1); plot(xid,dyi1,'b'); title('Method: nearest');
aax(2)=subplot(2,2,2); plot(xid,dyi2,'b'); title('Method:  linear');
aax(3)=subplot(2,2,3); plot(xid,dyi3,'b'); title('Method:   cubic');
aax(4)=subplot(2,2,4); plot(xid,dyi4,'b'); title('Method:  spline');
set(aax,'Xlim',[xis,xie]);

disp('PAUSE MODE - ZUM BEENDEN TASTE DRCKEN'); pause
close(fig1);
close(fig2);