% Einfhrung in einfaches Nhern von Daten mit Polynomen 
% Einige einfache Beispiele
%
% Autor: Winfried Kernbichler    21.11.1999
echo off; clc;
disp('Einfhrung in einfaches Nhern von Daten mit Polynomen');
disp('Autor: Winfried Kernbichler');
disp(' ');

% Definition von Variablen
xs = 0;
xe = 10;
xd = 1;
x = xs:xd:xe;
y = 0.3*x.^2 + 2.0*x;

% Strung der Daten mit Zufallszahlen
y = y + 0.5*y.*rand(size(y));

% Darstellung
fig = figure(1);
plot(x,y,'ko');
xlabel('x');
ylabel('y');

% Polynom Fit
p1 = polyfit(x,y,1); % Ordnung 1
p2 = polyfit(x,y,2); % Ordnung 2
disp('Fit liefert'); % Ausgabe der Polynome
disp(['2te Ordnung:  ',num2str(p2(1)),'*x^2 + ', ...
   					  	  num2str(p2(2)),'*x + '  , ...
                       num2str(p2(3)) ]);
disp(['1te Ordnung:  ',num2str(p1(1)),'*x + ', ...
   						  num2str(p1(2)) ]);
disp(' ');             

xn = xs:xd/10:xe;    % Engere Schrittweite zum Plotten der Polynome 
y1 = polyval(p1,xn); % Auswertung von Polynom p1
y2 = polyval(p2,xn); % und p2

hold on;
plot(xn,y1,xn,y2);
legend('data','1^{st}-degree','2^{nd}-degree',2);
hold off;

disp('PAUSE');pause;clc;

% Gerade durch den Nullpunkt (geht nicht mit polyfit)
% y = k*x, k: Steigung
d1 = x(x~=0).*y(x~=0);
d2 = x(x~=0).*x(x~=0);

k = mean(d1) ./ mean(d2);
y1a = k*xn; % Gerade durch den Nullpunkt
hold on;
plot(xn,y1a,'r:');
legend('data','1^{st}-degree','2^{nd}-degree','1^{st}-degree through 0',2);
hold off;

disp('PAUSE');pause;clc;
disp('DANKE')
