function varargout = htpopup(flag,val)

global figure_1
global axes_1
global axes_2
global popup_1
global listbox_1

if nargin == 0
  flag = 'init';
end

switch flag
case 'init'
  fontsize  = 0.03;
  fontunits = 'normalized';
  
  htpopup('init_figure_1');
  htpopup('init_axes_1');
  htpopup('init_axes_2');
  htpopup('init_popup_1');
  htpopup('init_listbox_1');
case 'init_figure_1'
  figure_1 = figure(1);clf
  set(figure_1, ...
      'Units','normalized' ...
      );
case 'init_axes_1'
  axes_1 = axes( ...
      'Parent',figure_1, ...
      'Units','normalized', ...
      'Position',[0 0 1 1], ...
      'Visible','off' ...
      );
case 'init_axes_2'
  xlim = [-5,5];
  ylim = [-5,5];
  axes_2 = axes( ...
      'Parent',figure_1, ...
      'Units','normalized', ...
      'Position',[0.1 0.3 0.8 0.6], ...
      'Color','default', ...
      'XLim',xlim, ...
      'YLim',ylim, ...
      'Box','on', ...
      'Visible','on' ...
      );                  
  xlabel('x');
  ylabel('y');                        
case 'init_popup_1'
  popup_1 = uicontrol('Style', 'popup', ...
      'Parent',figure_1, ...
      'Visible','on', ...
      'Units','normalized', ...
      'String', {'default','red','green','blue','black'}, ...
      'Value',1, ...
      'Position', [0.1 0.1 0.15 0.1], ...
      'Callback', 'htpopup popup_1');
case 'init_listbox_1'
  listbox_1 = uicontrol('Style', 'listbox', ...
      'Parent',figure_1, ...
      'Visible','on', ...
      'Units','normalized', ...
      'String',{'default','red','green','blue','black'}, ...
      'Value',1, ...
      'Position', [0.4 0.1 0.15 0.1], ...
      'Callback', 'htpopup listbox_1');   
case 'popup_1'
  lis = get(popup_1,'String');
  val = get(popup_1,'Value');
  set(axes_2,'Color',lis{val});
  set(listbox_1,'Value',val);
case 'listbox_1'
  lis = get(listbox_1,'String');
  val = get(listbox_1,'Value');
  set(axes_2,'Color',lis{val});
  set(popup_1,'Value',val);
end
          



