% Einfhrung in Schreiben und Lesen 
% Einige einfache Beispiele
%
% Autor: Winfried Kernbichler    21.11.1999
echo off; clc;
disp('Einfhrung in Schreiben und Lesen');
disp('Autor: Winfried Kernbichler');
disp(' ');

% Definition von Variablen
x = 0:pi/5:2*pi;
y = sin(x);
str = 'ynynynynyny';

% Zusammenfassen in einem Array
% funktioniert nur wenn str in ein Double-Array umgewandelt wird
arr = [x; y; double(str)]; 

% Formatiertes Schreiben auf einen File mit dem Namen test.dat
fid = fopen('test.dat','w');           % ffnen des Files
% Die Variable fid ist der File-Identifikator.
% Der Schirm entspricht fid=1 ; mu nicht geffnet werden.
fprintf(fid,'Zeit    Wert    Status\n'); % Schreiben einer berschrift
fprintf(fid,'--------------------\n');
fprintf(fid,'%7.4f %7.4f %c\n',arr);   % Schreiben von zwei formatierten Zahlen
                                       % und eines Buchstaben
fclose(fid);                           % Schlieen des Files
edit('test.dat');

disp('PAUSE');pause;clc

% Lschen der Variablen 
clear x y str arr

% ffnen eines bestehenden Files und Lesen
fid = fopen('test.dat');
fgetl(fid); % berliest Zeilen
fgetl(fid);
arr = fscanf(fid,'%f %f %c\n',[3 inf]); % Liest jeweils 3 Variablen bis zum Fileende
% Statt inf kann natrlich auch eine bestimmte Lnge angegeben werden
fclose(fid);

% Zuordnen der Variablen
x = arr(1,:);
y = arr(2,:);
str = char(arr(3,:)); % Macht aus den numerischen Codes wieder ein Char-Array 

fig = figure(1);
xn = x(str=='y'); % Nur jene Werte, wo in str 'y' (yes) steht.
yn = y(str=='y');
% Plotten von allen Datenpunkten (schwarz mit Kreisen)
% und Verbinden jener Punkte, wo im string ein y steht (blau, punktiert)
% Andere Plotanweisungen, siehe help plot 
pl1 = plot(x,y,'ko',xn,yn,'b:');
xlabel('x');
ylabel('y');
set(gca,'XLim',[0 2*pi]); % X-Limits im Achsensystem 
disp('PAUSE');pause;clc
close(fig);
disp('DANKE');

