function varargout = htradio(flag,val)

global figure_1
global edit_1
global text_1
global radio
global numedit
global fontsize

if nargin == 0
  flag = 'init';
end

switch flag
  case 'init'
    fontsize=0.5;
    numedit = 6;
    htradio('init_figure_1');
    htradio('init_text');
    htradio('init_edit');
    htradio('init_radio');
  case 'init_figure_1'
    figure_1 = figure(1);clf
    set(figure_1, ...
	'Units','normalized', ...
	'Position',[0.1 0.1 0.8 0.8] ...
	);
  case 'init_text'
    x1 = 0.1;  y1 = 0.9;
    x2 = 0.15; y2 = 0.05;
    dx = 0.0;  dy = -0.1;
    name = {'a-value','b-value','c-value','d-value','e-value','f-value','g-value'};
    for k = 1:numedit
      text_1(k) = uicontrol('Style','edit', ...
	  'Units','normalized', ...
	  'Position',[x1+(k-1)*dx,y1+(k-1)*dy,x2,y2], ...
	  'FontUnits','normalized', ...
	  'FontSize',fontsize, ...
	  'String',name{k} ...
	  );
   end
   
   set(text_1,'Parent',figure_1, ...
       'HorizontalAlignment','left', ...
       'Enable','inactive', ...
       'Visible','on');   
 case 'init_edit'
   x1 = 0.3;  y1 = 0.9;
   x2 = 0.15; y2 = 0.05;
   dx = 0.0;  dy = -0.1;
   val = rand(numedit);
   for k = 1:numedit
     edit_1(k) = uicontrol('Style','edit', ...
	 'Units','normalized', ...
	 'Position',[x1+(k-1)*dx,y1+(k-1)*dy,x2,y2], ...
	 'FontUnits','normalized', ...
	 'FontSize',fontsize, ...
	 'String', sprintf('%10.8f',val(k)) ...
	 ); 
   end
   set(edit_1,'Parent',figure_1, ...
       'HorizontalAlignment','left', ...
       'Enable','on', ...
       'Visible','on', ...
       'Callback', 'htradio edit');   
 case 'init_radio'
   x1 = 0.1; y1 = 0.1;
   x2 = 0.02; y2 = 0.03;
   dx = 0.2; dy = 0.0;
   val = [ 1 0 0 0];
   for k = 1:4
     radio(k) = uicontrol('Style','radiobutton','Value',val(k), ...
	 'Units','normalized', ...
	 'Position',[x1+(k-1)*dx,y1+(k-1)*dy,x2,y2] ...
	 ); 
   end
   set(radio,'Parent',figure_1,...
       'Visible','on','Max',1,'Min',0, ...
       'BackgroundColor','default', ...
       'ForegroundColor','red', ...
       'SelectionHighlight','off', ...
       'HorizontalAlignment','center', ...
       'Callback', 'htradio radio');
 case 'radio'
   gval = get(gcbo,'Value');
   list = radio(radio~=gcbo);
   set(list,'Value',~gval);
   val = get(radio,'Value');
 case 'edit'
   val=str2num(get(gcbo,'String'));
   if val < 0, val = 0.0; end
   if val > 1, val = 1.0; end
   if isempty(val), val = rand(1); end
   if length(val)>1, val=val(1); end
   set(gcbo,'String', sprintf('%10.8f',val));
end
          
