% Einfhrung in Save and Load 
% Einige einfache Beispiele
%
% Autor: Winfried Kernbichler    21.11.1999
echo off; clc;
disp('Einfhrung in Save and Load');
disp('Autor: Winfried Kernbichler');
disp(' ');

% Input von Variablen
disp('Darstellung von sin(l.*x)');
anz = input('Wie viele Datenpunkte in x-Richtung: ');
lim = input('Maximaler l-Wert:                    ');
disp('Danke');

% Berechnung des x-Vektors
xstart = 0; xend = 2*pi;
delta = (xend-xstart) / (anz-1);
x = xstart:delta:xend;

% Erzeugen eines Gitternetzes
%  Zwei Matrizen mit der Gre (length(x) mal lim)
%  L: Zeilenvektor [1:lim] wiederholt nach unten
%  X: Spaltenvektor x' wiederholt nach rechts
[L,X] = meshgrid(1:lim,x);

Y = sin(L.*X); % Enthlt nun Spalten mit sin(x);sin(2*x);sin(3*x);....

% Plotten von allen Sinus-Werten als Funktion von x
fig = figure(1);
pl1 = plot(x,Y);
xlabel('x');
ylabel('y');
set(gca,'XLim',[0 2*pi]); % X-Limits im Achsensystem 

% Speichern der Daten
disp('Speichern der Daten');
nam = input('Filename:                            ','s');
% Die zweite Variable 'nam' stellt sicher, da Daten als String geslesen werden.
SM = [x',Y];  % Matrix mit allen Daten
mnam = 'SM';  % Name der matrix
save(nam,mnam,'-ascii','-double');
% nam ist bereits ein String und mu nicht unter Hochkomma gestellt werden.
% 
% -ascii  stellt sicher, da der File auch auerhalb von Matlab lesbar ist
% -double stellt sicher, da alle Kommastellen geschrieben werden.
edit(nam); % ffnet den Editor 

% Lschen der Daten
clear SM L X x Y
 
disp('PAUSE');pause;clc

% Lesen der Daten
SM = load(nam); % Gleicher Filename wie vorher
% Matlab erkennt Inhalt, daher kein -ascii oder -double ntig
x  = SM(:,1); % Erste Spalte enthlt x-Werte
y1 = SM(:,2); % Zweite Spalte enthlt y1-Wert, ....
% Darstellung von einigen Werten mit Kreisen 
hold on;
plot(x(1:10:end),y1(1:10:end),'ko');
hold off;

disp('PAUSE');pause;clc
close(fig);
disp('DANKE');

