function p = legpol(n);
% Creates Legendre polynomial of order n
% Can be evaluated with polyval
% Written by Winfried Kernbichler
if mod(n,2) == 1
   m = 0:(n-1)/2;
else
   m = 0:n/2;
end

fac = [0:2*n]; fac(1) = 1; fac=cumprod(fac);

% ms = (-1).^m .* gamma(2*n-2*m+1) ./ gamma(m+1) ./ gamma(n-m+1) ./ gamma(n-2*m+1) / 2^n;
ms = (-1).^m .* fac(2*n-2*m+1) ./ fac(m+1) ./ fac(n-m+1) ./ fac(n-2*m+1) / 2^n;

p = zeros(1,n+1);
ind = 1:2:n+1;
p(ind) = ms;
