function [p] = myplot2(x,y,z,type)
% myplot1 stellt die Matrix z ber dem Gitternetz, das aus
% x und y gebildet wird dar.

if ( nargin ~= 4 )
   error('Falsche Anzahl von Inputparametern');
end

switch type
   case 'surf'
      p = surf(x,y,z);
   case 'surfng'
      p = surf(x,y,z);
      set(p,'EdgeColor','none');
   case 'surfc'
      p = surfc(x,y,z);
   case 'surfl'
      p = surfl(x,y,z);
   case 'density'
      p = surf(x,y,z);
      view(2);
      set(p,'EdgeColor','none');
   case 'densityint'
      p = surf(x,y,z);
      view(2);
      shading interp
      set(p,'EdgeColor','none'); 
   case 'mesh',   
      p = mesh(x,y,z);
   case 'meshc'
      p = meshc(x,y,z);
   case 'meshz'
      p = meshz(x,y,z);
   case 'waterfall'
      p = waterfall(x,y,z);
   otherwise
      fprintf(1,'Gltige Plottypen: \n\n');
      fprintf(1,'surf       : Surface Plot \n');
      fprintf(1,'surfng     : Surface Plot ohne Gridlines \n');
      fprintf(1,'surfc      : Surface Plot mit Contour Plot \n');
		fprintf(1,'surfl      : Surface Plot mit Beleuchtung \n');
		fprintf(1,'density    : Farbdichte Plot \n');
		fprintf(1,'densityint : Farbdichte Plot mit Interpolation \n');
      fprintf(1,'mesh       : Mesh Plot \n');
      fprintf(1,'meshc      : Mesh Plot mit Contourplot \n');
      fprintf(1,'meshz      : Mesh Plot mit Vorhang \n');
      fprintf(1,'waterfall  : Wasserfall Plot \n');
      fprintf(1,'\n\n');
      fprintf(1,'Bitte um Angabe eines richtigen Plottyps \n\n');
      p = [];
end

if ( ~isempty(p) ), xlabel('x'); ylabel('y'); zlabel('z'); end