phimin = pi/6 ;
phimax = pi/3;
phinum = 200;
r1 = 1.0;
r2 = 5.0;
cmin = 0.9;
cmax = 0;

phi = linspace(phimin, phimax, phinum);
cphi1 = cos(phi(1:end-1));
sphi1 = sin(phi(1:end-1));
cphi2 = cos(phi(2:end));
sphi2 = sin(phi(2:end));

x = [r1*cphi1;r2*cphi1;r2*cphi2;r1*cphi2;r1*cphi1];
y = [r1*sphi1;r2*sphi1;r2*sphi2;r1*sphi2;r1*sphi1];
c = linspace(cmin,cmax,phinum-1);

figure_1 = figure(1); clf;
ph_1 = patch(x,y,c);

ax_1 = gca;
set(ax_1,'XLim',[0 r2],'YLim',[0 r2]);
axis square;
caxis([0 1]);

set(ph_1,'EdgeColor','none');

colormap('default');
colorbar;

xr = [r1*cphi1(1),r2*cphi1,r2*cphi2(end),r1*cphi2(end),r1*fliplr(cphi1),r1*cphi1(1)];
yr = [r1*sphi1(1),r2*sphi1,r2*sphi2(end),r1*sphi2(end),r1*fliplr(sphi1),r1*sphi1(1)];

hold on;
line_1 = plot(xr,yr,'k','LineWidth',1.0);
hold off;
