% Script zur Lsung der Pendelschwingung
% Animation der Lsung in Realzeit
%
% Autor Winfried Kernbichler    23.01.2000
echo off; clc; disp(' ');disp(' ');
disp('Animation der Pendelgleichung');
disp(' ');disp(' ');

% Eingabe
method = dinput('Methode:',                 's', 'e',    {'e','l'}    );
om     = dinput('Grundfrequenz:',           [],  1.0,    'x>0 & x<10' );
kappa  = dinput('Dmpfung:',                [],  0.1,    'x>=0 & x<=10' );
p0     = dinput('Anfangswinkel:',           [],  0.0,    'abs(x)<=pi' );
o0     = dinput('Anfangsgeschwindigkeit:',  [],  1.9,    'abs(x)<=10' );
f0     = dinput('Kraftamplitude:',          [],  0.0,    'x>=0 & x<=10');
fomega = dinput('Frequenz der Kraft:',      [],  0.1,    'x>=0 & x<=10');
fphase = dinput('Phase der Kraft:',         [],  0.0,    'x>=0 & x<=pi');
numper = dinput('Anzahl der Perioden:',     [],  5,      [1:20]       );
numdat = dinput('Datenpunkte pro Periode:', [],  200,    [50 100 200 500 1000 1500] );
solver = dinput('Lsungsmethode:',          's', 'ode45',{'ode45','eulersol'} );
tail   = dinput('Taillnge:',               [],  50,     [50 100 150 200 250 300] );
disp(' '),disp(' ');

% Lsung der Differentialgleichung
[t,p,o]=pendel(method,om,kappa,p0,o0,f0,fomega,fphase,numper,numdat,solver);

% Darstellung und Animation
pendelplot(t,p,o,tail);

% Ende
clc;