% script10
%
% Demo: plotten von Funktionen mit Fehlerbalken - errorbar
%
% Autor:           Bernhard Seiwald
% Erstellt, am:    20.11.1999
% Modifiziert, am: 
%
% alle vorherigen Variablen lschen
clear all;
% Ausgabefenster lschen
clf;

% Daten laden
kerrtab = load('kerrtab-pu.dat');

% Daten in entsprechende Vektoren ablegen
%  U^2, \Delta U^2
spannung = kerrtab(:,1:2);
%  \varphi, \Delta \varphi
gruen    = kerrtab(:,3:4);
gelb     = kerrtab(:,5:6);
blau     = kerrtab(:,7:8);

% max. Wert fr r suchen und aufrunden
maxval = 10*ceil( max( max( kerrtab(:,3:8) ) ) / 10);

% Handle der Figur ermitteln
fig_handle = figure;

% Achsen festlegen
axis([0 max(spannung(:,1)) 0 maxval]);
hold on;

% Kurven zeichnen
g_handle = errorbar(spannung(:,1), gruen(:,1), gruen(:,2), 'g');
y_handle = errorbar(spannung(:,1), gelb(:,1),  gelb(:,2),  'y');
b_handle = errorbar(spannung(:,1), blau(:,1),  blau(:,2),  'b');

% handles in Vektor zusammenfassen
p_handles = [g_handle(1) y_handle(1) b_handle(1)];

% Legende erstellen
legend(p_handles, 'grn', 'gelb', 'blau', 0);

% Achsen beschriften
xlabel('U^2_{kerr} / V');
ylabel('\Delta \phi / rad');

% Titel
text_str = sprintf('%s %s',...
		   'Direkte Messung der Phasenverschiebung \Delta \phi',...
		   'bei verschiedenen Kerrspannungen U_{kerr}');
title(text_str);

hold off;
