% ********** Loesung zum Beispiel 8.1
% Autor: A. Pruell
% Datum: 11.05.2001


% *************    Eingabedaten

p   = [ 1, -3, -3, -4];         % Koeffizienten des Polynoms
sig = 15;                       % sigma des Rauschens
x   = linspace(-5,5,20);        % Datenvektor


% *************    Berechnungen    ***********************

% *************    Ausgabe des urspruenglichen Polynoms
%  berechne string zur formatierten Ausgabe des Polynoms
str = polyout(p);
disp(' ')
disp('Polynomfit ohne Einschraenkungen')
disp(['  urspruengliches Polynom: ',str])


% *************    plotte das urspr. Polynom Kurve und der 
%                  verrauschten Daten mit Fehlerbalken
xp = linspace(min(x),max(x)); % x-Vektor zum Plotten des urespr. Polynoms
yp = polyval(p,xp);           % y-Vektor zum Plotten des urespr. Polynoms
%close all                     % alle Figures schliessen
hf = figure(1);
p1 = plot(xp,yp,'k');         % Plot des exakten Polynoms
hold on


% *************    plotte verrauschten Daten mit Fehlerbalken
n = length(x);                % Laenge des Datenvektors
y = polyval(p,x);             % erzeuge y-Werte
y = y + sig*randn(1,n);       % verrausche y-Werte
%                               Plot der verrauschten Daten
p2 = errorbar(x,y,sig*ones(1,n),'kx');


% ************    berechne den Fit
pf = polyfit(x,y,length(p)-1);


% ************    plotte gefittetes Polynom
p3 = plot(xp,polyval(pf,xp),'g--');
hold off
% beschrifte den plot
legend([p1,p2(2),p3],'urspruengliches Polynom', ...
    ' verrauschte Daten', 'Polynomfit',0)


% ************    Ausgabe des geschaetzten Polynoms
%  berechne string zur formatierten Ausgabe des Polynoms
str = polyout(pf);
disp(['  rekontruiertes Polynom:  ',str])