% *************    Loesung zum Beispiel 8.2
% Autor: A. Pruell
% Datum: 11.05.2001


% *************    Eingabedaten

p   = [ 1, -3, -3, -4];         % Koeffizienten des Polynoms
pl  = [ 1,  0, 0,  1];          % Vektor der festen Koeffizienten
                                %  pl(i)=1  <==>  entsprechender Koeff.
                                %                 ist konstant
pc  = [ 1, -4];                 % Vektor der Konstanten
sig = 15;                       % sigma des Rauschens
x   = linspace(-5,5,20);        % Datenvektor


% *************    Berechnungen    ***********************

% *************    Ausgabe des urspruenglichen Polynoms
%  berechne string zur formatierten Ausgabe des Polynoms
str = polyout(p);
disp(' ')
disp('Polynomfit mit Einschraenkungen')
disp(['  urspruengliches Polynom: ',str])

% *************    Ausgabe der konstanten Koeffizienten
for j = 1:length(pl)
    if pl(j)
        disp(['   ',num2str(p(j)),' x^',num2str(length(pl)-j),'  fixiert!'])
    end
end
    

% *************    plotte das urspr. Polynom Kurve und der 
%                  verrauschten Daten mit Fehlerbalken
xp = linspace(min(x),max(x)); % x-Vektor zum Plotten des urespr. Polynoms
yp = polyval(p,xp);           % y-Vektor zum Plotten des urespr. Polynoms
%close all                     % alle Figures schliessen
hf = figure(2);
p1 = plot(xp,yp,'k');         % Plot des exakten Polynoms
hold on


% *************    plotte verrauschten Daten mit Fehlerbalken
n = length(x);                % Laenge des Datenvektors
y = polyval(p,x);             % erzeuge y-Werte
y = y + sig*randn(1,n);       % verrausche y-Werte
%                               Plot der verrauschten Daten
p2 = errorbar(x,y,sig*ones(1,n),'kx');


% *************    berechne den fit
x  = x(:);           % erzeuge Spaltenvektor
y  = y(:);           % erzeuge Spaltenvektor
pc = pc(:);          % erzeuge Spaltenvektor
pl = logical(pl);    % verwandle pl in eine logische Martix
np = length(p)-1;    % bestimme Grad des Polynoms
% berechne Matrix V =[x^n x^(n-1) .... 1]
V(:,np+1) = ones(length(x),1);   % Alternative waere ueber 
for j = np:-1:1                  % den Befehl meshgrid
   V(:,j) = x.*V(:,j+1);
end
% schneide Matrix fuer Gleichungssystem aus
V1 = V(:,~pl);       % Anteil der Matrix fuer die 
                     % nicht konstanten Koeff.
V2 = V(:,pl);        % Anteil der Matrix fuer die 
                     % konstanten Koeff.
% Inhomogenenvektor des Gleichungssystems
b = y - V2*pc;
% loese (ueberbestimmtes) GL-sys. mittels Least-Squares
pf1= V1\b;
% setze Polynomkoeff. zusammen
pf      = zeros(1,np+1);
pf(~pl) = pf1;       % gefittete Koeff.
pf(pl)  = pc;        % konstante Koeff.


% ************    plotte gefittetes Polynom
p3 = plot(xp,polyval(pf,xp),'g--');
hold off
% beschrifte den plot
legend([p1,p2(2),p3],'urspruengliches Polynom', ...
    ' verrauschte Daten', 'Polynomfit',0)


% ************    Ausgabe des geschaetzten Polynoms
%  berechne string zur formatierten Ausgabe des Polynoms
str = polyout(pf);
disp(['  rekontruiertes Polynom:  ',str])